# Copyright (C) 1999 by Juergen Pfeifer
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Jrgen Pfeifer <Juergen.Pfeifer@T-Online.de>
# ---------------------------------------------------------------------------
#
# GNU Ada RPM Packaging for LAPACK
#
%define        GNAT_TARGET_ARCH    i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        GNAT_TARGET_OS      Linux
%define        TARGET_OS           linux 
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_VERSION        3.11p
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    10
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        DEF_USER       bin
%define        DEF_GROUP      bin
#
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        CFG_PREFIX     /usr
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#dnl
#
%define        PKG_NAME       lapada
%define        PKG_VERSION    1
%define        PKG_RELEASE    1
#
%define        LAPADA_BASE    lapada
%define        SO_BASE        %{LAPADA_BASE}
%define        SO_MAJOR       %{PKG_VERSION}
%define        SO_MINOR       %{PKG_RELEASE}
#
%define        LAPADA_DIR     lapada
#
# ---------------------------------------------------------------------------
# We restrict the use of this package scipt at the moment to Intel and Linux.
# For sure there are details (compiler options, shared library building)
# that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{GNAT_TARGET_OS}
Packager:      Jrgen Pfeifer <Juergen.Pfeifer@t-online.de>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
# These are the official sources
Source0:       lapack-ada.tar.gz
#
# This is our patch
Patch0:        lapada.diff
#
#  ---------------------------------------------------------------------------
Copyright:     Free
Summary:       Runtime libraries for LAPACK 2.0 Binding
Summary(de):   Laufzeit-Bibliotheken des LAPACK 2.0 Bindings
Group:         Libraries
Obsoletes:     %{name}
Provides:      lib%{SO_BASE}.so.%{SO_MAJOR}
Requires:      %{GNAT_PKG_NAME} >= %{GNAT_PKG_VERSION}
Requires:      lapack = 2.0
Icon:          adarts.gif
Prefix:        %{CFG_PREFIX}
#
%description
This package includes the shared libraries required to run programs compiled
with the LAPACK 2.0 binding. LAPACK is a well known Linear Algebra package
written in FORTRAN.
#
%description -l de
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit dem LAPACK 2.0 Binding bersetzt wurden.
LAPACK ist ein bekanntes Paket mit Algorithmen der Linearen Algbra, welches
in FORTRAN geschrieben ist.
#
#  ---------------------------------------------------------------------------
%package devel
Summary:       Ada95 Packages with a LAPACK 2.0 binding.
Summary(de):   Ada95 Pakete fr ein LAPACK 2.0 Binding.
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name} = %{version}
Obsoletes:     %{name}-devel
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description devel
This is a set of Ada packages that allows you to write programs using the
LAPACK 2.0 Linear Algebra package written in FORTRAN.
#
%description -l de devel
Dies ist ein Sammlung von Ada Pakten die es Ihnen erlaubt, GNU Ada (GNAT)
Programme zu schreiben, die die LAPACK 2.0 Routinen zur Linearen Algebra
verwenden, welche in FORTRAN geschrieben sind.
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q  -n %{LAPADA_DIR}
%patch0 -p0 -b .lapada
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT/doc/test
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/lib

cd %{LAPADA_DIR}/ada
make -f Makefile.alt SO_MAJOR=%{SO_MAJOR} SO_MINOR=%{SO_MINOR}
cd ..
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
cd %{LAPADA_DIR}/ada
cp -pf lib%{LAPADA_BASE}.a $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf obj-static/*.ali    $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf obj-static/*.ad?    $RPM_BUILD_ROOT%{AINC_DIR}
#
chmod 0444 $RPM_BUILD_ROOT%{AINC_DIR}/*
chmod 0444 $RPM_BUILD_ROOT%{ALIB_DIR}/*
#
cp -pf lib%{LAPADA_BASE}.so \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
#
ln -sf lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LAPADA_BASE}.so.%{SO_MAJOR}
ln -sf lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LAPADA_BASE}.so
ln -sf ../../lib%{LAPADA_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   ${RPM_BUILD_ROOT}%{ALIB_DIR}/lib%{LAPADA_BASE}.so
#
cd ..
#
cp -pf  README    $RPM_BUILD_ROOT/doc
cp -pf  doc/*	  $RPM_BUILD_ROOT/doc
cp -prf test/*    $RPM_BUILD_ROOT/doc/test
#
find $RPM_BUILD_ROOT/doc -name '*.lapada' -exec rm -f {} \;
#  ---------------------------------------------------------------------------
%pre devel
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%postun
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%files devel
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{AINC_DIR}/*
%{ALIB_DIR}/*
#
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%{CFG_PREFIX}/lib/lib*.so*
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------
#
%changelog
* Tue Mar 09 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Created, Published as Release 1
